/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.project

import metridoc.utils.CollectionUtils.Sets

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 4/11/11
 * Time: 2:26 PM
 * To change this template use File | Settings | File Templates.
 */
@Mixin(IdSchemaGenerator.class)
class NormalizeDefinition {
    def ProjectDefinition projectDefinition;
    def Closure masterSchema
    def Closure masterLinkSchema
    def Closure linkColumnSchema
    def HashSet<String> linkTables = Sets.createHashSet()
    def SortedSet<String> include = Sets.createTreeSet()
    def HashSet<String> includeInMaster = Sets.createHashSet()
    def Map<String, Closure> normalizations = [:];
    def Map<String, Closure> schemas = [:]

    def include(String... columns) {
        include = columns
    }

    def includeInMaster(String... columns) {
        includeInMaster = columns
    }

    def linkTables(String... columns) {
        linkTables = columns
    }

    def schema(String name, Closure closure) {
        schemas[name] = closure
    }

    def normalize(String name, Closure closure) {
        normalizations[name] = closure
    }

    def Closure getAllSchemas(delegate) {

    }

    def Closure getNormalizedSchema(String name, delegate) {

    }

    def Closure getMasterSchemas(delegate) {
        def result = {
            if(masterSchema == null) {
                def name = projectDefinition.loadingTableDefinition.name
                def masterName = "${name}_master"
                changeLog(id: masterName, author:"metridoc") {
                    createTable(tableName:masterName) {
                        def idSchema = getIdSchema(masterName, delegate)
                        idSchema()
                        include.each {column ->
                            column(name: "${column}_id", type: "BIGINT UNSIGNED") {
                                constraints(nullable: false)
                            }
                        }
                    }
                }
            } else {
                masterSchema.delegate = delegate
                masterSchema()
            }
        }

        result.delegate = delegate

        return result
    }

    def Closure getLinkColumnSchema(String name, delegate) {

    }
}
