/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.project

import metridoc.utils.Assert

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 4/11/11
 * Time: 10:51 AM
 *
 * Represents the project definition for a project.  Assists with auto generating a project
 *
 */
class ProjectDefinition {

    def LoadingTableDefinition loadingTableDefinition
    def NormalizeDefinition normalizeDefinition
    def String dataSource

    def loadingTable(args, Closure closure) {
        Assert.notNull args.name, "a name must be specified for the loading table"
        Assert.notNull args.dataSource, "a dataSource must be specified for the loading table"
        dataSource = args.dataSource
        loadingTableDefinition = new LoadingTableDefinition(name: args.name)
        closure.delegate = loadingTableDefinition
        closure.setDirective Closure.DELEGATE_ONLY
        closure()
    }

    def normalize(Closure closure) {
        normalizeDefinition = new NormalizeDefinition(projectDefinition: this)
        closure.delegate = normalizeDefinition
        closure.setDirective Closure.DELEGATE_ONLY
        closure()
    }

}
